// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/telemetry_content
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/collaborators -i Collaborators -t ../../../assets/templates/middleware/telemetry_content -o telemetry_middleware.go -l ""

import (
	"context"
	"time"

	oid "git.perx.ru/perxis/perxis-go/id"
	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/collaborators"
	"git.perx.ru/perxis/perxis-go/pkg/telemetry/metrics"
	"go.opentelemetry.io/otel"
	"go.opentelemetry.io/otel/attribute"
	otelmetric "go.opentelemetry.io/otel/metric"
	"go.opentelemetry.io/otel/trace"
)

type spaceGetter interface {
	GetSpaceID() string
}

// telemetryMiddleware implements collaborators.Collaborators interface instrumented with opentracing spans
type telemetryMiddleware struct {
	collaborators.Collaborators
	_instance      string
	requestMetrics *metrics.RequestMetrics
	_spanDecorator func(span trace.Span, params, results map[string]interface{})
}

// TelemetryMiddleware returns telemetryMiddleware
func TelemetryMiddleware(base collaborators.Collaborators, instance string, spanDecorator ...func(span trace.Span, params, results map[string]interface{})) telemetryMiddleware {
	requestMetrics, err := metrics.GetRequestMetrics()
	if err != nil {
		panic(err)
	}

	d := telemetryMiddleware{
		Collaborators:  base,
		_instance:      instance,
		requestMetrics: requestMetrics,
	}

	if len(spanDecorator) > 0 && spanDecorator[0] != nil {
		d._spanDecorator = spanDecorator[0]
	}

	return d
}

// Get implements collaborators.Collaborators
func (_d telemetryMiddleware) Get(ctx context.Context, spaceId string, subject string) (role string, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Collaborators"),
		attribute.String("method", "Get"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Collaborators.Get")
	defer _span.End()

	role, err = _d.Collaborators.Get(ctx, spaceId, subject)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	spID = spaceId
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := oid.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":     ctx,
			"spaceId": spaceId,
			"subject": subject}, map[string]interface{}{
			"role": role,
			"err":  err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return role, err
}

// ListCollaborators implements collaborators.Collaborators
func (_d telemetryMiddleware) ListCollaborators(ctx context.Context, spaceId string) (collaborators []*collaborators.Collaborator, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Collaborators"),
		attribute.String("method", "ListCollaborators"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Collaborators.ListCollaborators")
	defer _span.End()

	collaborators, err = _d.Collaborators.ListCollaborators(ctx, spaceId)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	spID = spaceId
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := oid.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":     ctx,
			"spaceId": spaceId}, map[string]interface{}{
			"collaborators": collaborators,
			"err":           err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return collaborators, err
}

// ListSpaces implements collaborators.Collaborators
func (_d telemetryMiddleware) ListSpaces(ctx context.Context, subject string) (spaces []*collaborators.Collaborator, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Collaborators"),
		attribute.String("method", "ListSpaces"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Collaborators.ListSpaces")
	defer _span.End()

	spaces, err = _d.Collaborators.ListSpaces(ctx, subject)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	params := []interface{}{ctx, subject, spaces, err}
	for _, p := range params {
		if p == nil {
			continue
		}
		if sg, ok := p.(spaceGetter); ok {
			spID = sg.GetSpaceID()
			if spID != "" {
				break
			}
		}
	}
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := oid.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":     ctx,
			"subject": subject}, map[string]interface{}{
			"spaces": spaces,
			"err":    err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return spaces, err
}

// Remove implements collaborators.Collaborators
func (_d telemetryMiddleware) Remove(ctx context.Context, spaceId string, subject string) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Collaborators"),
		attribute.String("method", "Remove"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Collaborators.Remove")
	defer _span.End()

	err = _d.Collaborators.Remove(ctx, spaceId, subject)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	spID = spaceId
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := oid.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":     ctx,
			"spaceId": spaceId,
			"subject": subject}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}

// Set implements collaborators.Collaborators
func (_d telemetryMiddleware) Set(ctx context.Context, spaceId string, subject string, role string) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Collaborators"),
		attribute.String("method", "Set"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Collaborators.Set")
	defer _span.End()

	err = _d.Collaborators.Set(ctx, spaceId, subject, role)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	spID = spaceId
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := oid.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":     ctx,
			"spaceId": spaceId,
			"subject": subject,
			"role":    role}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}
