package transportgrpc

import (
	"git.perx.ru/perxis/perxis-go/pkg/content/versions/transport"
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	versions "git.perx.ru/perxis/perxis-go/pkg/version"
	pb "git.perx.ru/perxis/perxis-go/proto/versions/content"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc versions.Versions, opts ...grpckit.ServerOption) pb.VersionsServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		GetEndpoint: grpcerr.ServerMiddleware(eps.GetEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
